#include <Adafruit_SPIFlash.h>
#include <bluefruit.h>

// initialize advertised data packet
uint8_t user_data[3] = {0, 0, 0};

// initialize counter of advertised packet
uint8_t counter = 0;

// initialize advertised data packet
uint8_t scan_rsp_data[6] = {0, 0, 0, 0, 0, 0};


void startAdv(void)
{  
  // Set Flag for discovery mode, optional 
  //Bluefruit.Advertising.addFlags(BLE_GAP_ADV_FLAGS_LE_ONLY_LIMITED_DISC_MODE);

  // Construction of data packet to be advertised
  if (counter == 0xFF)
  {counter = 0;}
  else 
  {counter = counter + 1;}
  user_data[0] = 0x59;     // little endian format for first and second entry
  user_data[1] = 0x00;     // (00-59) means Nordic Semi
  user_data[2] = counter;  // third entry increments with each advertising cycle
  Bluefruit.Advertising.addData(BLE_GAP_AD_TYPE_MANUFACTURER_SPECIFIC_DATA, user_data, sizeof(user_data)/sizeof(user_data[0]));
  
  // add device name as scan response
  scan_rsp_data[0] = 0x59;     // little endian format for first and second entry
  scan_rsp_data[1] = 0x00;     // (00-59) means Nordic Semi
  scan_rsp_data[2] = 0xD1;      
  scan_rsp_data[3] = 0xD2;
  scan_rsp_data[4] = 0xD3;
  scan_rsp_data[5] = 0xD4;       
  Bluefruit.ScanResponse.addData(BLE_GAP_AD_TYPE_MANUFACTURER_SPECIFIC_DATA, scan_rsp_data, sizeof(scan_rsp_data)/sizeof(scan_rsp_data[0]));

  Bluefruit.Advertising.setType(BLE_GAP_ADV_TYPE_NONCONNECTABLE_SCANNABLE_UNDIRECTED);
  //Bluefruit.Advertising.setType(BLE_GAP_ADV_TYPE_CONNECTABLE_SCANNABLE_UNDIRECTED);
  Bluefruit.Advertising.restartOnDisconnect(true);
  Bluefruit.Advertising.setIntervalMS(100, 100);    // in unit of ms
  Bluefruit.Advertising.setFastTimeout(5);          // number of seconds in fast mode
  Bluefruit.Advertising.start(5);                   // stop advertising after 5 seconds
}


void setup()
{
  // Shut down unused QSPI flash memory
  Adafruit_FlashTransport_QSPI flashTransport;
  flashTransport.begin();
  flashTransport.runCommand(0xB9);
  flashTransport.end();

  // Enable DC-DC converter
  NRF_POWER->DCDCEN = 1;
  
  Bluefruit.begin();
  Bluefruit.autoConnLed(false); // turn off LED to save power
  Bluefruit.setTxPower(4);    // Check bluefruit.h for supported values
}

void loop()
{
  startAdv();
  __WFE();
  __WFI();
  delay(10000);  // advertising period = 10s
  Bluefruit.Advertising.clearData();  // refresh advertised data for each cycle
  Bluefruit.ScanResponse.clearData();  // refresh scan response data for each cycle
}
